function [F, dfM, dfE, p, SSM, SSE, MSM, MSE, eta, eps0] = teg_RMF_ANOVA(expanded0, X0, y_red_M, M_corr)

yMat = expanded0;

nSubj = size(yMat, 1);
subjM = mean(yMat, 2);
yMat = yMat - subjM * ones(1, size(yMat, 2));

X_ind = [];
for iX = 1:size(X0, 2),
    tmp = reshape(X0(:, iX), size(expanded0));
    X_ind = [X_ind mean(tmp)'];
end;
expanded0_red = zeros(size(expanded0));
for iSubj = 1:size(expanded0, 1),
    y = expanded0(iSubj, :);
    y = y(:);
    X = X_ind;
    b = inv(X'*X)*X'*y;
    model = X*b;
    expanded0_red(iSubj, :) = model;
end;

X = X0;
y = expanded0_red(:);
b = inv(X'*X)*X'*y;
model = X*b;
err = y - model;
SSM = sum(model.^2);
SSE = sum(err.^2);

[O2L, EV] = eig(cov(expanded0_red));
fnzev = find(diag(EV) > eps);
L = expanded0_red * O2L(:, fnzev);
S = cov(L);
eps0 = teg_get_eps(S);
dfM = size(X0, 2);
dfE = (nSubj - 1) * dfM;
dfM_adj = eps0 * dfM;
dfE_adj = eps0 * dfE; 
MSM = SSM / dfM;
MSE = SSE / dfE;
F = MSM / MSE;
p = teg_fsig(F, dfM_adj, dfE_adj);
eta = SSM / (SSM + SSE);
